<!DOCTYPE html><html lang="en"><head><meta charSet="utf-8"/><meta http-equiv="X-UA-Compatible" content="IE=edge"/><title>Proxy · Merge</title><meta name="viewport" content="width=device-width"/><meta name="generator" content="Docusaurus"/><meta name="description" content="&lt;p&gt;The portal proxy &lt;code&gt;px0&lt;/code&gt; provides &lt;em&gt;load balancing&lt;/em&gt; and &lt;em&gt;fault tolerance&lt;/em&gt; services for several components of the portal.&lt;/p&gt;
"/><meta name="docsearch:language" content="en"/><meta property="og:title" content="Proxy · Merge"/><meta property="og:type" content="website"/><meta property="og:url" content="https://mergetb.gitlab.io/index.html"/><meta property="og:description" content="&lt;p&gt;The portal proxy &lt;code&gt;px0&lt;/code&gt; provides &lt;em&gt;load balancing&lt;/em&gt; and &lt;em&gt;fault tolerance&lt;/em&gt; services for several components of the portal.&lt;/p&gt;
"/><meta property="og:image" content="https://mergetb.gitlab.io/img/logo.png"/><meta name="twitter:card" content="summary"/><meta name="twitter:image" content="https://mergetb.gitlab.io/img/logo.png"/><link rel="shortcut icon" href="/img/merge.png"/><link rel="stylesheet" href="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/styles/dracula.min.css"/><link rel="alternate" type="application/atom+xml" href="https://mergetb.gitlab.io/blog/atom.xml" title="Merge Blog ATOM Feed"/><link rel="alternate" type="application/rss+xml" href="https://mergetb.gitlab.io/blog/feed.xml" title="Merge Blog RSS Feed"/><script type="text/javascript" src="https://buttons.github.io/buttons.js"></script><link rel="stylesheet" href="/css/main.css"/></head><body class="sideNavVisible separateOnPageNav"><div class="fixedHeaderContainer"><div class="headerWrapper wrapper"><header><a href="/"><img class="logo" src="/img/merge-light.svg" alt="Merge"/><h2 class="headerTitleWithLogo">Merge</h2></a><div class="navigationWrapper navigationSlider"><nav class="slidingNav"><ul class="nav-site nav-site-internal"><li class=""><a href="/docs/hello-world.html" target="_self">Experimentation</a></li><li class=""><a href="/docs/site-basics.html" target="_self">Site Hosting</a></li><li class="siteNavGroupActive"><a href="/docs/portal-admin.html" target="_self">Portal Hosting</a></li><li class=""><a href="/docs/tech.html" target="_self">Technology</a></li><li class=""><a href="/blog/" target="_self">News</a></li></ul></nav></div></header></div></div><div class="navPusher"><div class="docMainWrapper wrapper"><div class="container docsNavContainer" id="docsNav"><nav class="toc"><div class="toggleNav"><section class="navWrapper wrapper"><div class="navBreadcrumb wrapper"><div class="navToggle" id="navToggler"><i></i></div><h2><i>›</i><span>Administration</span></h2><div class="tocToggler" id="tocToggler"><i class="icon-toc"></i></div></div><div class="navGroups"><div class="navGroup"><h3 class="navGroupCategoryTitle">Installation</h3><ul><li class="navListItem"><a class="navItem" href="/docs/portal-admin.html">Overview</a></li><li class="navListItem"><a class="navItem" href="/docs/install.html">Portal Installation</a></li></ul></div><div class="navGroup"><h3 class="navGroupCategoryTitle">Administration</h3><ul><li class="navListItem"><a class="navItem" href="/docs/net-admin.html">Networks</a></li><li class="navListItem"><a class="navItem" href="/docs/service-admin.html">Core Services</a></li><li class="navListItem"><a class="navItem" href="/docs/db-admin.html">Databases</a></li><li class="navListItem navListItemActive"><a class="navItem" href="/docs/proxy-admin.html">Proxy</a></li><li class="navListItem"><a class="navItem" href="/docs/user-admin.html">Users, Pools &amp; Projects</a></li><li class="navListItem"><a class="navItem" href="/docs/logs.html">Logs</a></li></ul></div></div></section></div><script>
            document.addEventListener('DOMContentLoaded', function() {
              createToggler('#navToggler', '#docsNav', 'docsSliderActive');
              createToggler('#tocToggler', 'body', 'tocActive');

              const headings = document.querySelector('.toc-headings');
              headings && headings.addEventListener('click', function(event) {
                if (event.target.tagName === 'A') {
                  document.body.classList.remove('tocActive');
                }
              }, false);

              function createToggler(togglerSelector, targetSelector, className) {
                var toggler = document.querySelector(togglerSelector);
                var target = document.querySelector(targetSelector);

                if (!toggler) {
                  return;
                }

                toggler.onclick = function(event) {
                  event.preventDefault();

                  target.classList.toggle(className);
                };
              }
            });
        </script></nav></div><div class="container mainContainer"><div class="wrapper"><div class="post"><header class="postHeader"><h1 class="postHeaderTitle">Proxy</h1></header><article><div><span><p>The portal proxy <code>px0</code> provides <em>load balancing</em> and <em>fault tolerance</em> services for several components of the portal.</p>
<ul>
<li>k8s masters</li>
<li>etcd instances</li>
</ul>
<p>The technology that provides these services is <a href="https://www.haproxy.com/">haproxy</a>. The haproxy configuration file is located at <code>/etc/haproxy/haproxy.cfg</code>. haproxy has excellent documentation located <a href="https://www.haproxy.org/#docs">here</a>.</p>
<p>The lifetime of haproxy is manged by <code>systemd</code>. The standard systemd functions can be used to manage it.</p>
<p>For lifecycle management</p>
<pre><code class="hljs css language-shell">service haproxy stop
service haproxy start
service haproxy restart
</code></pre>
<p>To see the haproxy logs</p>
<pre><code class="hljs css language-shell">journalctl -u haproxy
</code></pre>
<p>One can check the detailed status of haproxy through a special unix domain socket <code>/var/run/haproxy-stats.sock</code> as follows</p>
<pre><code class="hljs css language-shell">echo "show stat" | nc -U /var/run/haproxy-stats.sock | cut -d "," -f 1,2,5-11,18,24,27,30,36,50,37,56,57,62 | column -s, -t
</code></pre>
<pre><code class="hljs css language-shell"><span class="hljs-meta">#</span><span class="bash"> pxname        svname    scur  smax  slim  stot  bin  bout  dreq  status  lastchg  pid  throttle  rate_max  check_status  cli_abrt  lastsess  last_chk  ttime</span>
kube-api-front  FRONTEND  0     0     3000  0     0    0     0     OPEN             1              0
kube-api-back   ma0       0     0           0     0    0           UP      204      1              0         L4OK          0         -1                  0
kube-api-back   ma1       0     0           0     0    0           UP      204      1              0         L4OK          0         -1                  0
kube-api-back   ma2       0     0           0     0    0           UP      204      1              0         L4OK          0         -1                  0
kube-api-back   BACKEND   0     0     300   0     0    0     0     UP      204      1              0                       0         -1                  0
etcd-front      FRONTEND  0     0     3000  0     0    0     0     OPEN             1              0
etcd-back       db0       0     0           0     0    0           UP      204      1              0         L4OK          0         -1                  0
etcd-back       db1       0     0           0     0    0           UP      204      1              0         L4OK          0         -1                  0
etcd-back       db2       0     0           0     0    0           UP      204      1              0         L4OK          0         -1                  0
etcd-back       BACKEND   0     0     300   0     0    0     0     UP      204      1              0                       0         -1                  0
</code></pre>
</span></div></article></div><div class="docs-prevnext"><a class="docs-prev button" href="/docs/db-admin.html"><span class="arrow-prev">← </span><span>Databases</span></a><a class="docs-next button" href="/docs/user-admin.html"><span>Users, Pools &amp; Projects</span><span class="arrow-next"> →</span></a></div></div></div><nav class="onPageNav"></nav></div><footer class="nav-footer" id="footer"><section class="sitemap"><a href="/" class="nav-home"><img src="/img/merge-light.svg" alt="Merge" width="66" height="58"/></a><div><h5>Docs</h5><a href="/docs/en/hello-world.html">Experimentation</a><a href="/docs/en/site-basics.html">Site Hosting</a><a href="/docs/en/portal-admin.html">Portal Hosting</a></div><div><h5>Community</h5><a href="/en/users.html">User Showcase</a><a href="https://mergetb.slack.com/">Project Chat</a></div><div><h5>More</h5><a href="/blog">Blog</a><a href="https://gitlab.com/mergetb">GitLab</a></div></section><section class="copyright">Copyright © 2018 Information Sciences Institute</section></footer></div></body></html>